(***********************************************************************)
(*                                                                     *)
(*          Run-time Code Generation Library for Objective Caml        *)
(*                                                                     *)
(*                   Dmitri Lomov (dsl@tepkom.ru)                      *)
(*              St-Petersburg State University, Russia                 *)
(*                                                                     *)
(***********************************************************************)    

(* $Id: genHelper.ml,v 1.1.1.1 2002/02/28 11:11:01 mitya Exp $ *)

(*== tags manipulation ==*)
type data_tag = int

(*== tags manipulation ==*)
let unknown_tag = -1 
(* tag of any unboxed value (bool, int, char) *)
let unboxed_tag = 1024
let tuple_tag = 0
let ref_tag = 0

(*== Variables ==*)
(* location of a variable *)
type location =
    Environment of int * data_tag (* heap allocated environment *)
  | Stack of int * data_tag       (* temporary variables (let-bindings) *)
  | Param of int                  (* params *)

type t_variable = Code.id * location  

type t_environment = (t_variable,Code.id) Env.t


(*== Generation types  ==*)
type t_generation_state =
{
   env : t_environment;    (* current environment *)
   n_args : int;           (* number of function arguments *)
   mutable last_tag : int; (* tag of value generated last *)
} 

(*== any code ==*)

type any_code = Code.any Code.code


