#!/bin/awk -f

# $Header: /home/mitya/cvsroot/dml/bytecode/make-printer.awk,v 1.1.1.1 2002/02/28 11:11:01 mitya Exp $

function gen_print(type, param){
  if(type == "string")
    return "(printf \"%s\" " param ")";
  if(type == "comparison")
    return "(print_comparison " param ")"
  else
    return "(printf \"%d\" " param ")";
}

function gen_this(base, indent){
  n_items = 0;
  for(i = base + 2; i <= NF; i++)
    {
      if($i != "*" && $i != "list")
	n_items ++;
    }
  patt = (n_items > 0 ? "(":"");
  for(i = 0; i < n_items; i++)
    {
      if(i > 0) patt = patt ", ";
      patt = patt "x" i;
    }
  if(n_items > 0) patt = patt ")";
  printf indent $base patt " ->";
  print "   ";
  iparam = 0;
  instr_name = toupper(substr($base,2));
  print "printf \"" instr_name "\"";
  for(i = base + 2; i <= NF; i++)
    {
      if($i == "*" || $i == "list") 
	continue;
      printer = "; ";
      if($(i+1) == "list")
	{
	  patt = gen_print($i, "a");
	  printer = printer "print_list (fun a -> " patt ") x" iparam;
	}
      else
	{
	  patt = gen_print($i, "x" iparam);
	  printer = printer patt;
	}
      print printer "\n";
      iparam++;
    }
  print "; printf \"\\n\"\n";
}

BEGIN {
  print "open Printf\n";
  print "open Bytecode\n";
  print "let print_comparison c = ";
  matching = " match c with ";
  x["LT"] = "LT"; x["LE"] = "LE"; x["GT"] = "GT"; x["GE"] = "GE";
  x["EQ"] = "EQ"; x["NEQ"] = "NEQ";
  for(z in x)
    matching = matching z " -> " "\"" z "\" | ";
  matching = matching "  _ -> \"??\"";
  print "printf \"%s\" (" matching ")";
  print "let rec print_list p = function ";
  print "  []  -> printf \"[]\""
  print "| [x] -> p x";
  print "| h::t -> p h; print_list p t\n"
  print "let print_instr = function ";
  ORS = "";
}

$2 == "of" {  
  gen_this(1, "  ");
}

$1 == "|" {
  gen_this(2, "| ");
}



