# $Id: common.mak,v 1.2 2002/03/01 11:22:26 mitya Exp $
# common.mak
#  common makefile
#  
# Vars to be set:
#    INTERFACES - list of interfaces (without .mli)
#    MODULES - list of modules (without .ml)
#    LOCALINCS - local include dirs in form "<dir> <dir>..."
#    LIBS - local libs
# 

#CAMLP4_DIR = /usr/local/lib/camlp4
#OCAMLC=ocamlc 
#PPO=camlp4o
#OCAMLDEP=ocamldep
#INCLUDE=/usr/local/lib/ocaml
#CC=gcc 
#CFLAGS=
#OFLAGS=
#MAKE=make
include ../Makefile.in

# Do not edit below this line
INCLUDE:=$(OLIBDIR)
CFLAGS:=$(INCLUDE:%=-I%) $(CFLAGS)
OFLAGS:=$(LOCALINCS:%=-I %) $(OFLAGS)


ifdef DEBUG
	CFLAGS:=-g -DDEBUG $(CFLAGS)
	OFLAGS:=-g $(OFLAGS)
endif


start :: .depend $(TARGETS)

debug :	.depend
	$(MAKE) DEBUG=yes start

.SUFFIXES: .ml .dml .cmo .cmx .mli .cmi .mlii .c .o .d.o .ml4 .byte .dbyte

.ml.cmo:
	$(OC) -c $(OFLAGS) $<

.ml.cmx:
	$(OCAMLOPT) -c $(OFLAGS) $<

.mli.cmi:
	$(OC) -c $(OFLAGS) $<

.ml.mlii:
	$(OC) -c -i $(OFLAGS) $< >$@


%.ml : %.ml4
	$(PP4) -I $(P4DIR) pa_o.cmo pa_extend.cmo q_MLast.cmo pr_o.cmo -impl \
	$< > $@

# Syntax extensions (camlp4)
%.cmo : %.ml4
	@echo compile syntax extensions...
	$(OC) -pp \
	"$(PP4) -I $(P4DIR) pa_o.cmo pa_extend.cmo q_MLast.cmo pr_dump.cmo -impl " \
	-I $(P4DIR) $(OFLAGS) -c -impl $< 	

# For testing
%.ml: %.dml ../lib/dml.cmo
	$(PP4) -I $(P4DIR) pa_o.cmo ../lib/dml.cmo pr_o.cmo -impl $< >$@


# Dynamic Caml (RTCG syntax extensions)
%.cmo : %.dml
	$(OC) -c -pp "$(PP4) -I $(P4DIR) pa_o.cmo ../lib/dml.cmo pr_dump.cmo -impl" \
	     $(OFLAGS) -impl $< -o $@

%.o : %.c
	$(CC) -c $(CFLAGS) $< 

.cmo.byte:
	$(OC) -o $@ $(LIBS) ../lib/librtcg.a -custom \
	    ../lib/rtcg.cma ../lib/rtcgbyte.cma $<

.cmo.dbyte:
	$(OC) -o $@ $(LIBS) ../lib/librtcg.a -custom \
	    ../lib/rtcg.cma ../lib/rtcgbyte.cma $<

include .depend

.depend: $(MODULES:%=%.ml) $(INTERFACES:%=%.mli)
	ocamldep -I .. $(INTERFACES:%=%.mli) $(MODULES:%=%.ml) > .depend

clean::
	rm -f *.cmi *.cmo *.o *.cma *~ .depend core || true
	rm -f *.byte *.dbyte || true

#
# $Log: common.mak,v $
# Revision 1.2  2002/03/01 11:22:26  mitya
# %.ml: %.dml entry added
#
#
#









