open Pcaml

EXTEND
  GLOBAL: patt expr;

  expr: LEVEL "simple" [[ e = cdsimple -> e ]];
  expr: LEVEL "simple" [[ "{<"; e = cdexpr; ">}" -> e ]];

  cdsimple: [["`"; e = expr LEVEL "simple" -> <:expr< Rtcg.quote $e$ >> ]
            |["@"; e = expr LEVEL "simple" -> <:expr< $e$ >> ]
	    |["("; e = cdexpr; ")" -> e ]
 	    |[ "true"  -> <:expr< Rtcg.quote True  >> ]
 	    |[ "false" -> <:expr< Rtcg.quote False >> ]
 	    |[n = INT -> <:expr< Rtcg.quote $int:n$ >> ]
 	    (*|[n = CHAR -> <:expr< Cgen.quote $chr:n$ >> ]*)
 	    |[n = STRING -> <:expr< Rtcg.quote $str:n$ >> ]
 	    |[n = LIDENT -> <:expr< $lid:n$ >> ]
            ];

  lambda_tail: [ [ p = patt LEVEL "simple"; 
		   e = [ "->"; e = cdexpr -> e 
                   | m = lambda_tail -> <:expr< Rtcg.eval (Rtcg.abstr $m$) >>
                 ] -> <:expr< fun $p$ -> $e$ >> ]];


  cdexpr: [ "expr1" [ "if"; c = cdexpr LEVEL "expr1"; "then"; th = cdexpr; "else"; el = cdexpr -> <:expr< Rtcg.if' $c$ $th$ $el$ >> ]
          |           [ "for"; var=patt; "="; bot=cdexpr; 
			dir=["to" -> <:expr<Rtcg.DTo>> | "downto" -> <:expr<Rtcg.DDownTo>>]; 
			top=cdexpr; "do"; body=cdexpr; "done" ->
		      <:expr< Rtcg.for' $bot$ $dir$ $top$ (fun $var$ -> $body$) >> ]
         |         [ "let"; r = OPT "rec"; p = patt; "="; e = cdexpr; "in"; e' = cdexpr -> 
	                    match r with 
			    | Some _ -> <:expr< let $p$ = Cgen.fix (fun $p$ -> $e$) in $ e'$ >> 
			    | None   -> <:expr< Rtcg.let' $e$ (fun $p$ -> $ e'$) >>
		    ]
(*	  |         [ "mac"; mac = lambda_tail -> <:expr< Cgen.macro $mac$ >> ] *)
          |         [ "fun"; mac = lambda_tail -> <:expr< eval (abstr $mac$) >> ] 
          | "=" NONA  [ a = cdexpr; "=" ; b = cdexpr -> <:expr< Rtcg.eq $a$ $b$ >> ]
(*          |           [ a = cdexpr; "<>"; b = cdexpr -> <:expr< Cgen.ine  ($a$, $b$) >> ]
          |           [ a = cdexpr; "<" ; b = cdexpr -> <:expr< Cgen.ilt  ($a$, $b$) >> ]
          |           [ a = cdexpr; "<="; b = cdexpr -> <:expr< Cgen.ile  ($a$, $b$) >> ]
          |           [ a = cdexpr; ">" ; b = cdexpr -> <:expr< Cgen.igt  ($a$, $b$) >> ]
          |           [ a = cdexpr; ">="; b = cdexpr -> <:expr< Cgen.ige  ($a$, $b$) >> ]*)
          | "+" LEFTA [ a = cdexpr;  "+"; b = cdexpr -> <:expr< Rtcg.int_bin $a$ Rtcg.IOpADD $b$ >> ]
          |           [ a = cdexpr;  "-"; b = cdexpr -> <:expr< Rtcg.int_bin $a$ Rtcg.IOpSUB $b$ >> ]
          | "*" LEFTA [ a = cdexpr;  "*"; b = cdexpr -> <:expr< Rtcg.int_bin $a$ Rtcg.IOpMUL $b$  >> ]
          |           [ a = cdexpr;  "/"; b = cdexpr -> <:expr< Rtcg.int_bin $a$ Rtcg.IOpDIV $b$  >> ]
          |           [ a = cdexpr; "mod"; b = cdexpr -> <:expr< Rtcg.int_bin $a$ Rtcg.IOpMOD $b$  >> ]
(*	  | "unary minus" [ "-"; a = cdexpr -> <:expr< Cgen.ineg $a$ >> ]*)
	  | "apply" LEFTA [ f = cdexpr; arg = cdexpr -> <:expr< Rtcg.apply $f$ $arg$ >> ]
(*	  | "." LEFTA [ a = cdexpr LEVEL "simple"; "."; "("; i = cdexpr; ")" -> <:expr< Cgen.slice ($a$, $i$) >> 
	              | a = cdexpr LEVEL "simple"; "."; f = LIDENT -> 
			  let p = <:patt< $lid:f$ >> in
			  <:expr< Cgen.apply (Cgen.quote (fun {$f$ = _field } -> _field)) $a$ >> 
	              | e = cdexpr LEVEL "simple" -> e ] *)
	  | "simple" [ e = cdsimple -> e ]];

END;;




