(* $Header: /home/mitya/cvsroot/dml/tests/t1.ml,v 1.1.1.1 2002/02/28 11:11:02 mitya Exp $ *)

open Rtcg;;
open Eval;;

set_unsafe true;

let f3 = eval (abstr (fun x -> 
  (if' (eq x (quote 1)) (quote true) (quote false)))) in 

let fact = 
  eval (fix (fun f -> 
    (abstr (fun x -> 
      (if' (eq x (quote 1)) (quote 1)
	 (int_bin x IOpMUL (apply f 
			      (int_bin x IOpSUB (quote 1))))))))) in
let fstringget = eval (abstr (fun s ->
  (abstr (fun i -> (string_get s i)))))
in
let flet = eval (abstr (fun x -> 
  (int_bin x IOpADD (let' (quote 1) (fun y -> 
    (let' x (fun z -> (int_bin y IOpMUL z)))))))) in
let print_int i = Printf.printf "%d " i in
let ffor = eval (abstr (fun x->
  (for' (quote 10) DDownTo x (fun i -> (apply (quote print_int) i))))) in
let ffor1 = eval (abstr (fun x->
  (seq
     (for' (quote 0) DTo x (fun i -> (apply (quote print_int) i)))
     (apply (quote ffor) x)))) in

let farray = eval (abstr (fun x ->
  (abstr (fun i -> (array_get x i))))) in

let farray1 = eval (abstr (fun x ->
  (array_get (quote [|1.1;2.1;3.1|]) x))) in
let farray2 = eval (abstr (fun x ->
  (abstr (fun i -> (int_bin (array_get x i) IOpADD (quote 1)))))) in

let fclrarray = eval (abstr (fun a ->
  (for' (quote 0) DTo (int_bin (array_length a) IOpSUB (quote 1))
     (fun i -> (array_set a i (quote 1.1)))))) in

let fboolean = eval (abstr (fun x ->
  (if' (bor (int_cmp x LE (quote 1)) (int_cmp x GE (quote 2)))
     (seq (apply (quote (Printf.printf "%s")) (quote "yes")) (quote true))
     (seq (apply (quote (Printf.printf "%s")) (quote "no")) (quote false))))) 
in
let fboolean1 = eval (abstr (fun x ->
  (band (seq (apply (quote print_int) x) (int_cmp x GE (quote 0)))
     (seq (apply (quote print_int) (int_bin x IOpADD (quote 1))) 
	(quote true)))))
in
let fequal = eval(abstr(fun x -> (abstr(fun y -> (equal x y))))) in
let farraytest = 
  eval(abstr(fun i -> let' (quote [|1;2;3;4;5;6|])
      (fun a -> array_get a i))) in
let fdoublearraytest = 
  eval(abstr(fun i -> let' (quote [|1.0;2.0;3.0;4.0;5.0;6.0|])
      (fun a -> array_get a i))) in

let ftuple2 = 
  eval(abstr(fun a -> abstr (fun b -> (tuple2 a b)))) in

let ftuple3 = 
  eval(abstr(fun a -> abstr (fun b -> (tuple3 a b a)))) in

let fslice =
  eval(abstr(fun i -> let' (quote (1.1,0.1,1.1)) (fun t ->
    (slice31 t)))) in

let ffloat =
  eval(abstr(fun x -> float_bin x FLOP_ADD (quote 1.))) in

let flet1 = 
  eval(abstr(fun x ->
      let' (abstr (fun x -> x)) (fun f -> apply f x))) in

let fref =
  eval(abstr(fun i ->
    let' (ref_create i) (fun r -> ref_value r))) in

let fref1 = 
  eval(abstr(fun r -> ref_value r)) in

let fref2 = 
  eval(abstr(fun i -> ref_create i)) in

let fref3 = 
  eval(abstr(fun r -> ref_set r (quote "abcd"))) in


let fwhile =
  eval(abstr(fun n ->
    let' (ref_create (quote 0)) 
      (fun i ->
	(while' (int_cmp (ref_value i) LT n)
	   (seq
	      (apply (quote (Printf.printf "%d ")) (ref_value i))
	      (ref_set i (int_bin (ref_value i) IOpADD (quote 1)))))))) in 

     
Printf.printf "f3 ===> %s\n" (if (f3 1) then "true" else "false"); 
Printf.printf "10! ===> %d\n" (fact 10);
Printf.printf "flet ===> %d\n" (flet 9);
Printf.printf "array_get ===> %d\n" (farray [|1;2;3|] 2);
Printf.printf "fboolean ===> %b\n" (fboolean 0);
Printf.printf "fboolean1 ===> %b\n" (fboolean1 (2));
Printf.printf "array_get2 ===> %d\n" (farray2 [|1;2;3|] 1);
Printf.printf "fstringget ===> %c\n" (fstringget "abc" 2);
Printf.printf "fequal ===> %b\n" (fequal [1;2;3] [1;2;5]);
Printf.printf "farraytest ===> %d\n" (farraytest 1);
Printf.printf "fdoublearraytest ===> %f\n" (fdoublearraytest 1);
let a,b = (ftuple2 "a" "b") in
Printf.printf "ftuple2 ===> %s %s\n" a b;
let a,b,c = (ftuple3 "a" "b") in
Printf.printf "ftuple3 ===> %s %s %s\n" a b c;
Printf.printf "fslice ===> %f\n" (fslice ());
Printf.printf "ffloat ===> %f\n" (ffloat 2.5);
Printf.printf "flet1 ===> %d\n" (flet1 2);
Printf.printf "fref ===> %d\n" (fref 2);
Printf.printf "fref1 ===> %d\n" (fref1 (ref 27));
Printf.printf "fref2 ===> %d\n" !(fref2 27);
let r = ref "uvw" in
(fref3 r );
Printf.printf "fref3 ===> %s\n" !r;
fwhile 15; Printf.printf "\n";

let s = "abs" in
eval 
  (abstr(fun s -> (abstr (fun i -> (string_set s i (quote '$'))))))
  s 0; 
Printf.printf "%s\n" s;

let a = [|1.1;2.1;3.1|] in
fclrarray a;
for i = 0 to (Array.length a)-1 do
  Printf.printf "%f\n" a.(i)
done;

(ffor 11);
(ffor1 5);
Printf.printf "\n"





